#
# A simple Tcl/TK script to scan a domain to and check that the 
# guest account is disabled on all the systems.
#
# Displays a TK window with the status for each computer
# this may take a long time to complete, especially if many of the computers in your
# domain are not running (it's a long timeout).
#

load ntsys

set machlist [NT_UserEnum [NT_GetDCName {}] FILTER_WORKSTATION_TRUST_ACCOUNT]
append machlist [NT_UserEnum [NT_GetDCName {}] FILTER_SERVER_TRUST_ACCOUNT]

proc dispUG {id } {
  global av
  
  if {![info exists av]} {
    set av 0
  }

  set id [string range 0 [expr [string last $id (] - 2]]
  set id [string trimright $id]
  
  set nw .dlg[incr av]
  set nwt [set nw].txt

  toplevel $nw

  text $nwt
  
  $nwt insert end "machine = $id\n"
  catch {NT_UserGetInfo "\\\\$id" guest} msg
  $nwt insert end "$msg\n"

  pack $nwt
  update

}

text .lb -width 80 -height 20 -yscrollcommand ".sb set"
scrollbar .sb -command {.lb yview}

pack .sb -side right -fill y
pack .lb -side left 
bind .lb <Double-Button-1> {dispUG [.lb get "[lindex [split [.lb index current] .] 0].0" "[expr [lindex [split [.lb index current] .] 0] + 1 ].0" ]}

foreach a $machlist {
  lappend ul [string trimright [lindex $a 0] $]
}

.lb tag configure error -foreground red
.lb tag configure warning -foreground yellow
.lb tag configure safe -foreground green

foreach a $ul { 
  set found [catch {set info [NT_UserGetInfo "\\\\$a" guest]} msg]
  if {$found==0} {
    set flags [lindex $info 3]
    if {![string match *ACCOUNTDISABLE* $flags]} {
     set nok [catch {NT_UserSetInfo "\\\\$a" guest flags UF_SCRIPT|UF_NORMAL_ACCOUNT|UF_ACCOUNTDISABLE} msg]
     if {$nok} {
      .lb insert end "$a (NOT FIXED: $msg)\n" error
     } else {
      .lb insert end "$a (fixed)\n" safe
     }
    } else {
    .lb insert end "$a\n" safe
    }
  } else {
    .lb insert end "$a ($msg)\n" warning
  }
  update
}

